# Monitor I2C Sensors

![Screenshot](images/mpu6050.gif?raw=true "6 DOF inertial measurement unit MPU6050")

## Procedure for using I2C sensors

- Scan for Sensors
- Click to monitor via analog gauge
- List of I2C sensors supported thus far (Minimal data logging. Configuration options via the graphical utility might be incomplete)
	- MPU6050 3 Axis Accelerometer, 3 axis Angular velocity (Gyro)
	- MPU9250 9-DOF sensor
	- MS5611 : 24 bit pressure and temperature sensor. Can resolve 15cm height variations
	- TSL2561 Luminosity measurements
	- BMP280 Pressure and Temperature sensor
	- MCP4725 Single channel DAC
	- PCA9685 PWM controller
	- MLX90614 Passive IR

## Reading with Python Code
Check out the [Programmer's manual for sensors](../programming/i2c)

## Luminosity sensor(TSL2561) Example

A light sensor is being monitored with the flash of the camera enabled. As the camera approaches the sensor,
the readings go up. Not a very clever example. TODO.

Luminosity sensor(TSL2561) Example. | Video recording
---|---
![sensor](https://user-images.githubusercontent.com/19327143/52988950-5c64f580-3427-11e9-8516-d6708ef2532b.gif) | ![ezgif com-optimize](https://user-images.githubusercontent.com/19327143/52989158-2bd18b80-3428-11e9-9b26-21f21f8fe99a.gif)

[Project Example with TSL2561 light sensor: Malus Law](../malus)
